$ Title IO Table Aggregation (108 Sector IO to 17 sector IO)
* Ch. 11 in Hosoe et al. (2015) Textbook of CGE Modeling, 2nd edition, University of Tokyo Press

set	u0	original io labels	/001*146/
	u	aggregated io labels
		/AGR	agriculture incl. livestock feed,
		OIL	oil coal and natural gas,
		MIN	other mining,
		FOD	food beverage and tobacco
		TXA	textiles and apparel
		WPP	wood paper and printing
		P_C	petroleum and coal product,
		CHM	other chemical,
		POT	pottery,
		STL	steel and metal products,
		MAN	machinery and other manufacturing,
		EEQ	electric equipment,
		TEQ	transportation equipment,
		ELY	electricity,
		TWG	town gas,
		TRS	transportation and storage,
		SRV	other services
		CAP, LAB, IDT, TRF, HOH, GOV, INV, EXT/

		i(u)	sectors
			/AGR, OIL, MIN, FOD, TXA, WPP, P_C, CHM, POT,
			STL, MAN, EEQ, TEQ, ELY, TWG, TRS, SRV/

		h(u)	factors	/CAP,LAB/

	u0_imports(u0)	entries related to imports and tariffs
			/125*127/;
set	u_agg(u0, u)	aggregation of the original IO table
/
(001*005,011).			AGR
008.				OIL
(006*007).			MIN
(009*010,012).			FOD
(013*014,032).			TXA
(015*019).			WPP
(022,028*029).			P_C
(020*021,023*027,030*031).	CHM
(033*036).			POT
(037*044).			STL
(045*048,062*063).		MAN
(049*056).			EEQ
(057*061).			TEQ
069.				ELY
070.				TWG
(078*085).			TRS
(064*068,071*077,086*108).	SRV
(142*144).			CAP
(140*141).			LAB
(145*146).			IDT
(126*127).			TRF
(111*112).			HOH
(113*114).			GOV
(115*117).			INV
(122,125).			EXT
/;

set	v_agg(u0, u)	aggregation of the original IO table
/
(001*005,011).			AGR
008.				OIL
(006*007).			MIN
(009*010,012).			FOD
(013*014,032).			TXA
(015*019).			WPP
(022,028*029).			P_C
(020*021,023*027,030*031).	CHM
(033*036).			POT
(037*044).			STL
(045*048,062*063).		MAN
(049*056).			EEQ
(057*061).			TEQ
069.				ELY
070.				TWG
(078*085).			TRS
(064*068,071*077,086*108).	SRV
(142*144).			CAP
(140*141).			LAB
(145*146).			IDT
(126*127).			TRF
(111*112).			HOH
(113*114).			GOV
(115*117).			INV
(122,125).			EXT
/;

alias (u0,v0),(u,v), (i,j);


$CALL GDXXRW.EXE io05a301.xls o=io2005 par=IO0 rng=io2005!C4:DY120

Parameter	IO0(u0,v0)	original input-output table
		IO(u,v)		aggregated input-output table
		SAM(u,v)	social accounting matrix;
* Loading IO table
$gdxin io2005.gdx
$loaddc IO0
$gdxin


* Transposing imports and tariffs
IO0(u0_imports,v0)=-IO0(v0,u0_imports);
IO0(v0,u0_imports)=0;

* Aggregating IO Table
IO(u,v)=sum(u_agg(u0,u), sum(v_agg(v0,v), IO0(u0,v0)));

SAM(u,v)=IO(u,v);

* Factor endowment
SAM("HOH",h)=sum(j, SAM(h,j));

* Indirect taxes revenue
SAM("GOV","IDT")=sum(j, SAM("IDT",j));
SAM("GOV","TRF")=sum(j, SAM("TRF",j));

* Direct tax
* Source: SNA, CY2005/H17
* 4. General government:
* Current taxes + Social contributions -Social benefits
SAM("GOV","HOH")=(41675.4+53216.5-56606.4)*1000;

* Savings
SAM("INV","HOH")=sum(h, SAM("HOH",h))
		-sum(i, SAM(i,"HOH"))-SAM("GOV","HOH");
SAM("INV","GOV")=SAM("GOV","HOH")+sum(j, SAM("IDT",j)+SAM("TRF",j))
		-sum(i, SAM(i,"GOV"));
SAM("INV","EXT")=sum(i, SAM("EXT",i)-SAM(i,"EXT"));

execute_unload "SAM2005.gdx" SAM;
